/*******************************************************************************
 *
 * blueMarine - open source photo workflow
 * =======================================
 *
 * Copyright (C) 2003-2009 by Fabrizio Giudici
 * Project home page: http://bluemarine.tidalwave.it
 *
 *******************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); 
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at 
 * 
 *     http://www.apache.org/licenses/LICENSE-2.0 
 * 
 * Unless required by applicable law or agreed to in writing, software 
 * distributed under the License is distributed on an "AS IS" BASIS, 
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
 * See the License for the specific language governing permissions and 
 * limitations under the License. 
 *
 *******************************************************************************
 *
 * $Id: MakerNotePersistenceSourceSink.java,v d7e8fed5e750 2009/09/17 23:55:58 fabrizio $
 *
 ******************************************************************************/
package it.tidalwave.metadata.makernote.persistence;

import it.tidalwave.imageio.cr2.CanonCR2MakerNote;
import it.tidalwave.imageio.crw.CanonCRWMakerNote;
import it.tidalwave.imageio.mrw.MinoltaMakerNote;
import it.tidalwave.imageio.nef.NikonMakerNote3;
import it.tidalwave.imageio.orf.OlympusMakerNote;
import it.tidalwave.imageio.pef.PentaxMakerNote;
import it.tidalwave.imageio.raw.Directory;
import it.tidalwave.metadata.Metadata;
import it.tidalwave.metadata.persistence.spi.MetadataItemPersistenceSupport;

/*******************************************************************************
 *
 * This class provides persistence support for metadata items for maker notes
 * based on the {@link Directory} class.
 *
 * @author  Fabrizio Giudici
 * @version $Id: MakerNotePersistenceSourceSink.java,v d7e8fed5e750 2009/09/17 23:55:58 fabrizio $
 *
 ******************************************************************************/
public class MakerNotePersistenceSourceSink extends MetadataItemPersistenceSupport<Directory>
  {
    public MakerNotePersistenceSourceSink()
      throws Exception
      {
        super(Directory.class, "MakerNote Persistence", Metadata.StorageType.INTERNAL, "MakerNote");
        persistenceSpi.register(NikonMakerNote3.class, new MakerNoteBeanAccessor<NikonMakerNote3>(NikonMakerNote3.class, "Nikon MakerNote 3"));
        persistenceSpi.register(CanonCR2MakerNote.class, new MakerNoteBeanAccessor<CanonCR2MakerNote>(CanonCR2MakerNote.class, "Canon MakerNote CR2"));
        persistenceSpi.register(CanonCRWMakerNote.class, new MakerNoteBeanAccessor<CanonCRWMakerNote>(CanonCRWMakerNote.class, "Canon MakerNote CRW"));
        persistenceSpi.register(MinoltaMakerNote.class, new MakerNoteBeanAccessor<MinoltaMakerNote>(MinoltaMakerNote.class, "Minolta MakerNote MRW"));
        persistenceSpi.register(PentaxMakerNote.class, new MakerNoteBeanAccessor<PentaxMakerNote>(PentaxMakerNote.class, "Pentax MakerNote PEF"));
        persistenceSpi.register(OlympusMakerNote.class, new MakerNoteBeanAccessor<OlympusMakerNote>(OlympusMakerNote.class, "Olympus MakerNote ORF"));
      }
  }
